package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.ShopOrderCartInfoService;
import com.gxwebsoft.shop.entity.ShopOrderCartInfo;
import com.gxwebsoft.shop.param.ShopOrderCartInfoParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 订单购物详情表控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 21:05:07
 */
@Api(tags = "订单购物详情表管理")
@RestController
@RequestMapping("/api/shop/shop-order-cart-info")
public class ShopOrderCartInfoController extends BaseController {
    @Resource
    private ShopOrderCartInfoService shopOrderCartInfoService;

    @ApiOperation("分页查询订单购物详情表")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopOrderCartInfo>> page(ShopOrderCartInfoParam param) {
        // 使用关联查询
        return success(shopOrderCartInfoService.pageRel(param));
    }

    @ApiOperation("查询全部订单购物详情表")
    @GetMapping()
    public ApiResult<List<ShopOrderCartInfo>> list(ShopOrderCartInfoParam param) {
        PageParam<ShopOrderCartInfo, ShopOrderCartInfoParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(shopOrderCartInfoService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(shopOrderCartInfoService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopOrderCartInfo:list')")
    @OperationLog
    @ApiOperation("根据id查询订单购物详情表")
    @GetMapping("/{id}")
    public ApiResult<ShopOrderCartInfo> get(@PathVariable("id") Integer id) {
        return success(shopOrderCartInfoService.getById(id));
        // 使用关联查询
        //return success(shopOrderCartInfoService.getByIdRel(id));
    }

    @ApiOperation("添加订单购物详情表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopOrderCartInfo shopOrderCartInfo) {
        if (shopOrderCartInfoService.save(shopOrderCartInfo)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改订单购物详情表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopOrderCartInfo shopOrderCartInfo) {
        if (shopOrderCartInfoService.updateById(shopOrderCartInfo)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除订单购物详情表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopOrderCartInfoService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加订单购物详情表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopOrderCartInfo> list) {
        if (shopOrderCartInfoService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改订单购物详情表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopOrderCartInfo> batchParam) {
        if (batchParam.update(shopOrderCartInfoService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除订单购物详情表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopOrderCartInfoService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
